#include "INTRINS.H"
#include "STC8H.h"
#include "pwm_table.h"

#define MAIN_Fosc 44236800L // ʱ
// ܶ
#define u8 unsigned char
#define u16 unsigned int
#define u32 unsigned long

/**/
void PLL_Init(void);  // PLLʱӲֳʼ
void PWMA_Init(void); // PWMAֳʼ
void PWMB_Init(void); // PWMBֳʼ
char ReadPWMA(char addr);
void WritePWMA(char addr, char dat);
char ReadPWMB(char addr);
void WritePWMB(char addr, char dat); // 첽дPWMA,B
void GPIO_Init(void);				 // IOڲֳʼ
void Update_IO_Mode(void);			 // IO
void Set_Moto_Dir(u8 motox, u8 dir);
void Set_PWMA_Period(u16 hz, u16 duty);
void Set_PWMB_Period(u16 hz, u16 duty, u8 num);
void Set_Moto_Config(u8 motox, u16 out_duty, u16 diff_duty, u8 dir); // õ
void Timer1_Init(void);
void Uart2_Init(void);
/*ȫֱ*/
#define Sync_Mode 0
#define Async_Mode 1
u8 Mode = Sync_Mode; // Ĭͬģʽ

#define HIN1 P21
#define HIN2 P23
#define HIN3 P25
#define HIN4 P27

#define LIN1_1 P20
#define LIN2_1 P22
#define LIN3_1 P24
#define LIN4_1 P26

#define LIN1_2 P00
#define LIN2_2 P01
#define LIN3_2 P02
#define LIN4_2 P03

u8 Moto1_Dir = 0, Moto2_Dir = 0; // ķ
u16 in_pwm = 0;
u8 uart_cnt = 0;																  // ڽռ
int uart_dat_out1 = 0, uart_dat_out2 = 0, uart_dat_diff1 = 0, uart_dat_diff2 = 0; // ڽ
u8 uart_set[10] = {0};
/**/
void main(void)
{
	P_SW2 |= 0x80; // SFRչ
	PWMA_Init();
	PWMB_Init();
	Timer1_Init(); // ʱ,ڲⲿ
	Uart2_Init();
	GPIO_Init();
	EA = 1;
	while (1)
	{
		if (in_pwm == 0) // ûź
		{
			if (uart_dat_out1 > 0)
			{
				Set_Moto_Config(1, uart_dat_out1, uart_dat_diff1, 0);
			}
			else
			{
				Set_Moto_Config(1, -uart_dat_out1, uart_dat_diff1, 1);
			}
			if (uart_dat_out2 > 0)
			{
				Set_Moto_Config(2, uart_dat_out2, uart_dat_diff2, 0);
			}
			else
			{
				Set_Moto_Config(2, -uart_dat_out2, uart_dat_diff2, 1);
			}
		}
		else
		{
			Set_Moto_Config(1, (u16)(((float)(in_pwm - 3200) / (float)(7800 - 3200)) * 1000.0), 10, 0);
			Set_Moto_Config(2, (u16)(((float)(in_pwm - 3200) / (float)(7800 - 3200)) * 1000.0), 10, 1);
		}
	}
}

/*ຯ*/
void Update_IO_Mode(void) // IO
{
	PWMA_ENO = 0x00;
	PWMB_ENO = 0x00;					   // ȫض
	HIN1 = HIN2 = HIN3 = HIN4 = 1;		   // ߽ת
	LIN1_1 = LIN2_1 = LIN3_1 = LIN4_1 = 1; // ȫ߷
	LIN1_2 = LIN2_2 = LIN3_2 = LIN4_2 = 1; // ߣ
	switch (Moto1_Dir * 10 + Moto2_Dir)
	{
	case 00:	  // 
		HIN2 = 0; // һֱ
		HIN4 = 0; // һֱ
		PWMA_ENO = 0x33;
		PWMB_ENO = 0x44;
		break;
	case 01:	  // 
		HIN2 = 0; // һֱ
		HIN3 = 0; // һֱ
		PWMA_ENO = 0xc3;
		PWMB_ENO = 0x14;
		break;
	case 10:	  // 
		HIN1 = 0; // һֱ
		HIN4 = 0; // һֱ
		PWMA_ENO = 0x3c;
		PWMB_ENO = 0x41;
		break;
	case 11:	  // 
		HIN1 = 0; // һֱ
		HIN3 = 0; // һֱ
		PWMA_ENO = 0xcc;
		PWMB_ENO = 0x11;
		break;

	default:
		break;
	}
}

// һķ͵ڶķ,ʱһIOģʽ
void Set_Moto_Dir(u8 motox, u8 dir)
{
	if (motox > 2 || dir > 1)
		return; // 쳣뷵
	if (motox == 1)
	{
		if (Moto1_Dir != dir)
		{
			Moto1_Dir = dir;
			Update_IO_Mode();
		}
	}
	if (motox == 2)
	{
		if (Moto2_Dir != dir)
		{
			Moto2_Dir = dir;
			Update_IO_Mode();
		}
	}
}

void GPIO_Init(void)
{
	P0M0 = 0x0f;
	P0M1 = 0xff;
	P1M0 = 0x00;
	P1M1 = 0xfc;
	P2M0 = 0xff;
	P2M1 = 0x55;
	// PWMصֿ©ֹźųͻҪõʱ
	// ֱӿPWMx_ENOIO״̬Ϊ߼ɱͻ
	P3M0 &= ~0xfc;
	P3M1 = (P3M1 & ~0x08) | 0xf4;
	P3PU |= 0x04; // 򿪰
	P0PU = 0x0f;  // PWM
	P2PU = 0x55;
	P2SR = 0x00; // PWM˿ʵ
	P2DR = 0x00;
	P0SR &= ~0x0f;
	P0DR &= ~0x0f;
	Set_Moto_Dir(1, 0);
	Set_Moto_Dir(2, 0);
	Mode = Async_Mode; // Ϊͬģʽ
}

// Ҫʹú궨MAIN_Fosc,pwmںռձȣdutyΧ0~1000hzĵλHznumͨ
// HZķΧ100~10000
float arr_tmp = 0, test_tmp = 0;
void Set_PWMA_Period(u16 hz, u16 duty) // PWMҪȫλ
{
	if (hz > 10000 || duty > 1000 || hz < 100)
		return;
	PWMA_PSCR = 9;
	test_tmp = hz;
	arr_tmp = ((float)MAIN_Fosc / ((float)hz * 10.0));
	if (arr_tmp > 60000)
		arr_tmp = 60000;
	PWMA_ARR = (u16)(arr_tmp);
	PWMA_CCR1 = (u16)(((float)duty / 1000.0) * (float)arr_tmp);
	PWMA_CCR2 = (u16)(((float)duty / 1000.0) * (float)arr_tmp);
	PWMA_CCR3 = (u16)(((float)duty / 1000.0) * (float)arr_tmp);
	PWMA_CCR4 = (u16)(((float)duty / 1000.0) * (float)arr_tmp);
}

void Set_PWMB_Period(u16 hz, u16 duty, u8 num)
{
	u16 arr_tmp = 0;
	if (hz > 30000 || duty > 1000 || num > 4 || hz < 100)
		return;
	PWMB_PSCR = 29;
	arr_tmp = (u16)(MAIN_Fosc / ((u32)hz * 30));
	PWMB_ARR = arr_tmp;
	switch (num)
	{
	case 1:
	case 2:
		PWMB_CCR5 = (u16)(((float)duty / 1000.0) * (float)arr_tmp);
		PWMB_CCR6 = (u16)(((float)duty / 1000.0) * (float)arr_tmp);
		break;
	case 3:
	case 4:
		PWMB_CCR7 = (u16)(((float)duty / 1000.0) * (float)arr_tmp);
		PWMB_CCR8 = (u16)(((float)duty / 1000.0) * (float)arr_tmp);
		break;
	default:
		break;
	}
}

void Set_Moto_Config(u8 motox, u16 out_duty, u16 diff_duty, u8 dir)
// ѡõĵ(1,2)õռձ100.0%(0~1000)
// õĲռձ100.0%(0~1000),ֵ(1,2)õķ(0,1)
{
	u16 hz_tmp = 0; // жǷлģʽĻֵ
	if (motox > 2 || out_duty > 1000 || diff_duty > 1000 || dir > 1)
		return;														 // 쳣ִֵܾ
	Set_PWMA_Period((u16)(((float)out_duty * 9.9) + 100), out_duty); // ƣͳһ
	Set_Moto_Dir(motox, dir);
	if (motox == 1)
	{
		// һ
		if (Moto1_Dir == 0)
		{
			// ת
			Set_PWMB_Period((u16)(((float)out_duty * 9.9) + 100) * 3, (u16)(diff_duty), 1);
		}
		else
		{
			// ת
			Set_PWMB_Period((u16)(((float)out_duty * 9.9) + 100) * 3, (u16)(diff_duty), 2);
		}
	}
	else
	{
		// ڶ
		if (Moto2_Dir == 0)
		{
			// ת
			Set_PWMB_Period((u16)(((float)out_duty * 9.9) + 100) * 3, (u16)(diff_duty), 3);
		}
		else
		{
			// ת
			Set_PWMB_Period((u16)(((float)out_duty * 9.9) + 100) * 3, (u16)(diff_duty), 4);
		}
	}
}

// 첽дPWM
char ReadPWMA(char addr)
{
	char dat;
	while (HSPWMA_ADR & 0x80)
		;					  // ȴд
	HSPWMA_ADR = addr | 0x80; // üʵַ
	while (HSPWMA_ADR & 0x80)
		;			  // ȴǰ첽д
	dat = HSPWMA_DAT; // ȡ첽
	return dat;
}

void WritePWMA(char addr, char dat)
{
	while (HSPWMA_ADR & 0x80)
		;
	HSPWMA_DAT = dat;		  // д
	HSPWMA_ADR = addr & 0x7f; // λд0ʾд
}

// PWMB
//  첽дPWM
char ReadPWMB(char addr)
{
	char dat;
	while (HSPWMB_ADR & 0x80)
		;					  // ȴд
	HSPWMB_ADR = addr | 0x80; // üʵַ
	while (HSPWMB_ADR & 0x80)
		;			  // ȴǰ첽д
	dat = HSPWMB_DAT; // ȡ첽
	return dat;
}

void WritePWMB(char addr, char dat)
{
	while (HSPWMB_ADR & 0x80)
		;
	HSPWMB_DAT = dat;		  // д
	HSPWMB_ADR = addr & 0x7f; // λд0ʾд
}

void PLL_Init(void)
{
	// PLLƵ
	CLKSEL = 0xc0; // 򿪸IOʱx12λʱԴѡ񲻱
	PLLCR = 0xc0;  // ʹPLLƵƵ/3ʵIOʱΪ44.2368/3*12=176.9412Mhz
	HSCLKDIV = 0;  // ʱӲƵ
	HSPWMA_CFG = 0x03;
	HSPWMB_CFG = 0x03;
}

// PWMPWM
void PWMA_Init(void)
{
	P_SW2 |= 0x80;	   // SFR enable
	PWMA_PS = 0x55;	   // P2x˿
	PWMA_CCER1 = 0x00; // CCERx,ſԽCCMR
	PWMA_CCER2 = 0x00; // CCERx,ſԽCCMR
	PWMA_CCMR1 = 0x78; // ͨźȫ,ȫʹԤװ
	PWMA_CCMR2 = 0x78; // ͨźȫ
	PWMA_CCMR3 = 0x78; // ͨźȫ
	PWMA_CCMR4 = 0x78; // ͨźȫ
	PWMA_CCER1 = 0x55; // ȫʹ
	PWMA_CCER2 = 0x55; //
	// PWMA_SMCR = 0x24;  // ıͨΪڲIT2,ΪλģʽPWMBڽиλ
	PWMA_SMCR = 0x26; // ıͨΪڲIT2,ΪſģʽPWMBڽиλ
	PWMA_BKR = 0x80;  // ʹ
	PWMA_CR1 = 0x81;  // Զװأʱ,PWMBлʹPWMAиλ
}

// PWMPWM
void PWMB_Init(void)
{
	P_SW2 |= 0x80;	   // SFR enable
	PWMB_PS = 0xaa;	   // P0x˿
	PWMB_CCER1 = 0x00; // CCERx,ſԽCCMR
	PWMB_CCER2 = 0x00; // CCERx,ſԽCCMR
	PWMB_CCMR1 = 0x78; // ͨźȫ,ȫʹԤװ
	PWMB_CCMR2 = 0x78; // ͨźȫ
	PWMB_CCMR3 = 0x78; // ͨźȫ
	PWMB_CCMR4 = 0x78; // ͨźȫ
	PWMB_CCER1 = 0x11; // ȫʹ
	PWMB_CCER2 = 0x11; //
	PWMB_CR2 = 0x40;   // Ϊʱ䴥TRGO
	// PWMB_CR2 = 0x20;   // Ϊʱ䴥TRGO
	PWMB_BKR = 0x80; // ʹ
	PWMB_CR1 = 0x85; // Զװأʱ
}

/*ȡPWM벿*/
void INT1_Isr(void) interrupt 2
{
	TR1 = 0; // ͣʱ
	in_pwm = ((u16)TH1 << 8 | TL1);
	if (in_pwm > 7800)
		in_pwm = 7800;
	if (in_pwm < 3300)
		in_pwm = 3200;
	TL1 = 0x00;
	TH1 = 0x00;
	TR1 = 1; // ¿ʼ
}

void Timer1_Init(void) // 100΢@44.2368MHz
{
	AUXR &= 0xBF; // ʱʱ12Tģʽ
	TMOD &= 0x0F; // öʱģʽ
	TMOD |= 0x90; // GATEģʽ,INT1Ϊ1ʱʹܼʱ,Զװģʽ
	TL1 = 0x00;	  // öʱʼֵ
	TH1 = 0x00;	  // öʱʼֵ
	TR1 = 1;	  // ʱ1ʼʱ
	IT1 = 1;	  // INT1½ж
	EX1 = 1;	  // INT1ж
}

u8 crc_add = 0, crc_cnt = 0;
void Uart2_Isr(void) interrupt 8
{
	if (S2CON & 0x02) // ⴮2ж
	{
		S2CON &= ~0x02; // 2жλ
	}
	if (S2CON & 0x01) // ⴮2ж
	{
		S2CON &= ~0x01; // 2жλ
		if (uart_cnt != 0)
		{
			uart_set[uart_cnt] = S2BUF;
			uart_cnt++;
			if (uart_cnt == 10)
			{
				uart_cnt = 0;
				crc_add = 0;
				for (crc_cnt = 0; crc_cnt < 9; crc_cnt++)
				{
					crc_add += uart_set[crc_cnt];
				}
				if (crc_add == uart_set[9])
				{
					// ݽ
					uart_dat_out1 = (int)(uart_set[1] << 8 | uart_set[2]);
					uart_dat_out2 = (int)(uart_set[3] << 8 | uart_set[4]);
					uart_dat_diff1 = (int)(uart_set[5] << 8 | uart_set[6]);
					uart_dat_diff2 = (int)(uart_set[7] << 8 | uart_set[8]);
					if (uart_dat_out1 > 1000)
						uart_dat_out1 = 1000;
					if (uart_dat_out1 < -1000)
						uart_dat_out1 = -1000;
					if (uart_dat_out2 > 1000)
						uart_dat_out2 = 1000;
					if (uart_dat_out2 < -1000)
						uart_dat_out2 = -1000;
					if (uart_dat_diff1 > 1000)
						uart_dat_diff1 = 1000; // ޷
					if (uart_dat_diff1 < 0)
						uart_dat_diff1 = 0;
					if (uart_dat_diff2 > 1000)
						uart_dat_diff2 = 1000; // ޷
					if (uart_dat_diff2 < 0)
						uart_dat_diff2 = 0;
				}
			}
		}
		if (S2BUF == 0x55 && uart_cnt == 0)
		{
			uart_set[uart_cnt] = S2BUF;
			uart_cnt++;
		}
	}
}

void Uart2_Init(void) // 115200bps@44.2368MHz
{
	S2CON = 0x50; // 8λ,ɱ䲨
	AUXR |= 0x04; // ʱʱ1Tģʽ
	T2L = 0xA0;	  // öʱʼֵ
	T2H = 0xFF;	  // öʱʼֵ
	AUXR |= 0x10; // ʱ2ʼʱ
	IE2 |= 0x01;  // ʹܴ2ж
}
